<?php

namespace phil\HabboFont2\addons;

abstract class Addon
{
    abstract public function getImagePath();

    abstract public function getPositionType();

    abstract public function initializeCoords();

    abstract public function zIndex();

    abstract public static function getClass();

    private static $_instance = null;

    public static function get()
    {

        if (self::$_instance == null) {
            $class = static::getClass();
            self::$_instance = new $class;
        }

        return self::$_instance;
    }

    private $_image_size = null;

    public function getSize()
    {

        if ($this->_image_size == null) {
            $this->_image_size = getImageSize($this->getImagePath());
        }

        return $this->_image_size;
    }

    public function __construct()
    {
        $this->initializeCoords();
    }

    public function getX()
    {
        return $this->_x;
    }

    public function getY()
    {
        return $this->_y;
    }

    private $_x = 0;

    private $_y = 0;

    private $_width = 0;

    private $_height = 0;

    /**
     * @return mixed
     */
    public function getWidth()
    {

        return $this->getSize()[0];
    }

    public function setX($x)
    {
        $this->_x = $x;
    }

    public function setY($y)
    {
        $this->_y = $y;
    }

    /**
     * @return mixed
     */
    public function getHeight()
    {

        return $this->getSize()[1];
    }
}