<?php

namespace phil\HabboFont2\artist;

use phil\HabboFont2\fonts\Font;

class Char
{

    private $_char;

    private $_font;

    private $_image_size = null;

    private $_image_path;

    public function __construct($char, Font $font)
    {

        $this->_char = $char;
        $this->_font = $font;

        $image_path = $font->getDirectory() . "chars/" . $char . ".png";
        $this->_image_path = $image_path;
        $this->_image_size = getImageSize($this->_image_path);
    }

    /**
     * @return string
     */
    public function getImagePath()
    {

        return $this->_image_path;
    }

    public function getWidth()
    {

        return $this->_image_size[0];
    }

    public function getHeight()
    {

        return $this->_image_size[1];
    }
}