<?php

namespace phil\HabboFont2\cache;

use phil\HabboFont2\artist\BlankImage;

class CacheImage
{
	private $_image_path;
	private $_image;

	private $_width;
	private $_height;

	public function __construct($image_path) {
		$this->_image_path = $image_path;

		$image_size = getImageSize($image_path);
		$this->_width = $image_size[0];
		$this->_height = $image_size[1];

		$this->_image = $this->createImage();
	}

	private function createImage()
	{
		$image = imageCreateTrueColor($this->getWidth(), $this->getHeight());
		imageSaveAlpha($image, true);
		$color = imageColorAllocateAlpha($image, 0, 0, 0, 127);
		imageFill($image, 0, 0, $color);

		$text_image = imageCreateFromPNG($this->_image_path);
		imageCopyResampled($image, $text_image, 0, 0, 0, 0, $this->getWidth(), $this->getHeight(), $this->getWidth(), $this->getHeight());

		return $image;
	}

	public function getImagePath()
	{
		return $this->_image_path;
	}

	public function getImage()
	{
		return $this->_image;
	}

	/**
	 * @return mixed
	 */
	public function getWidth() {

		return $this->_width;
	}

	/**
	 * @return mixed
	 */
	public function getHeight() {

		return $this->_height;
	}
}